import { HttpClient } from '@wix/sdk-types';
import { GetWidgetSettingsResponse, GetWidgetSettingsResponseNonNullableFields, SetWidgetSettingsResponse, SetWidgetSettingsResponseNonNullableFields, WidgetSettings } from './innovation-widget-v1-widget-settings-widget-settings.universal.js';
export declare const __metadata: {
    PACKAGE_NAME: string;
};
export declare function getWidgetSettings(httpClient: HttpClient): GetWidgetSettingsSignature;
interface GetWidgetSettingsSignature {
    /**
     * Retrieves the widget settings for the site.
     */
    (): Promise<GetWidgetSettingsResponse & GetWidgetSettingsResponseNonNullableFields>;
}
export declare function setWidgetSettings(httpClient: HttpClient): SetWidgetSettingsSignature;
interface SetWidgetSettingsSignature {
    /**
     * Sets the widget settings for the site.
     * @param - Widget settings to update.
     */
    (widgetSettings: WidgetSettings): Promise<SetWidgetSettingsResponse & SetWidgetSettingsResponseNonNullableFields>;
}
export { ActiveHours, Conditions, ContactForm, DaySchedule, ExtendedFields, Fields, GetWidgetSettingsRequest, GetWidgetSettingsResponse, GetWidgetSettingsResponseNonNullableFields, IntroMessage, OfflineBehavior, Schedule, SetWidgetSettingsRequest, SetWidgetSettingsResponse, SetWidgetSettingsResponseNonNullableFields, SettingsMessage, WidgetSettings, WorkingHoursFrame, } from './innovation-widget-v1-widget-settings-widget-settings.universal.js';
