"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.setWidgetSettings = exports.getWidgetSettings = void 0;
const rest_modules_1 = require("@wix/sdk-runtime/rest-modules");
const timestamp_1 = require("@wix/sdk-runtime/transformations/timestamp");
const timestamp_2 = require("@wix/sdk-runtime/transformations/timestamp");
const transform_paths_1 = require("@wix/sdk-runtime/transformations/transform-paths");
const rest_modules_2 = require("@wix/sdk-runtime/rest-modules");
function resolveWixInnovationAssistantWidgetV1SettingsUrl(opts) {
    const domainToMappings = {
        'manage._base_domain_': [
            {
                srcPath: '/wix-assistant-widget',
                destPath: '',
            },
        ],
        _: [
            {
                srcPath: '/wix-assistant-widget',
                destPath: '',
            },
        ],
        'editor._base_domain_': [
            {
                srcPath: '/wix-assistant-widget',
                destPath: '',
            },
        ],
        'blocks._base_domain_': [
            {
                srcPath: '/wix-assistant-widget',
                destPath: '',
            },
        ],
        'create.editorx': [
            {
                srcPath: '/wix-assistant-widget',
                destPath: '',
            },
        ],
        '*.dev.wix-code.com': [
            {
                srcPath: '/wix-assistant-widget',
                destPath: '',
            },
        ],
        'editor.wixapps.net': [
            {
                srcPath: '/wix-assistant-widget',
                destPath: '',
            },
        ],
        'www.wixapis.com': [
            {
                srcPath: '/wix-assistant-widget',
                destPath: '',
            },
        ],
        'www._base_domain_': [
            {
                srcPath: '/_api/wix-assistant-widget',
                destPath: '',
            },
        ],
    };
    return (0, rest_modules_2.resolveUrl)(Object.assign(opts, { domainToMappings }));
}
const PACKAGE_NAME = '@wix/auto_sdk_ai-site-chat_widget-settings';
/** Retrieves the widget settings for the site. */
function getWidgetSettings(payload) {
    function __getWidgetSettings({ host }) {
        const metadata = {
            entityFqdn: 'wix.innovation.widget.v1.widget_settings',
            method: 'GET',
            methodFqn: 'wix.innovation.assistant.widget.v1.Settings.GetWidgetSettings',
            packageName: PACKAGE_NAME,
            url: resolveWixInnovationAssistantWidgetV1SettingsUrl({
                protoPath: '/v1/settings',
                data: payload,
                host,
            }),
            params: (0, rest_modules_1.toURLSearchParams)(payload),
            transformResponse: (payload) => (0, transform_paths_1.transformPaths)(payload, [
                {
                    transformFn: timestamp_2.transformRESTTimestampToSDKTimestamp,
                    paths: [
                        { path: 'widgetSettings.createdDate' },
                        { path: 'widgetSettings.updatedDate' },
                    ],
                },
            ]),
        };
        return metadata;
    }
    return __getWidgetSettings;
}
exports.getWidgetSettings = getWidgetSettings;
/** Sets the widget settings for the site. */
function setWidgetSettings(payload) {
    function __setWidgetSettings({ host }) {
        const serializedData = (0, transform_paths_1.transformPaths)(payload, [
            {
                transformFn: timestamp_1.transformSDKTimestampToRESTTimestamp,
                paths: [
                    { path: 'widgetSettings.createdDate' },
                    { path: 'widgetSettings.updatedDate' },
                ],
            },
        ]);
        const metadata = {
            entityFqdn: 'wix.innovation.widget.v1.widget_settings',
            method: 'POST',
            methodFqn: 'wix.innovation.assistant.widget.v1.Settings.SetWidgetSettings',
            packageName: PACKAGE_NAME,
            url: resolveWixInnovationAssistantWidgetV1SettingsUrl({
                protoPath: '/v1/settings',
                data: serializedData,
                host,
            }),
            data: serializedData,
            transformResponse: (payload) => (0, transform_paths_1.transformPaths)(payload, [
                {
                    transformFn: timestamp_2.transformRESTTimestampToSDKTimestamp,
                    paths: [
                        { path: 'widgetSettings.createdDate' },
                        { path: 'widgetSettings.updatedDate' },
                    ],
                },
            ]),
        };
        return metadata;
    }
    return __setWidgetSettings;
}
exports.setWidgetSettings = setWidgetSettings;
//# sourceMappingURL=innovation-widget-v1-widget-settings-widget-settings.http.js.map